unit drawmodelpivotunit;

interface

uses
  Classes, SysUtils, ModelUnit, MeshUnit, gl, glu, sdl, openglunit;
  
  
procedure DrawModelPivot(model:TModel);

implementation

procedure ApplyTrans(tran:TTransformation);
begin
with tran.Pos do
 glTranslatef(x,y,z);
with tran.Rot do
 begin
  glRotatef(x, 1,0,0);
  glRotatef(y, 0,1,0);
  glRotatef(z, 0,0,1);
 end;
with tran.Sca do
 glScalef(x,y,z);

end;

procedure ToggleFaceMode;
var i:integer;
begin
glGetIntegerv(gl_front_face, @i);
if i=GL_CCW then glFrontFace(gl_CW) else glFrontFace(gl_CCW);

end;

procedure DrawTreeNode(node:TModelTreeNode);
var i:integer;
    t:boolean;
begin
// apply transformations to matrix
glPushMatrix;
ApplyTrans(node.transf);

// see if i have to toggle face mode
with node.transf do
t:=sca.x*sca.y*sca.z <0;

if t then ToggleFaceMode;

draworiginlines(0.1);

for i:=0 to node.children.count-1 do
 DrawTreeNode(node.children[i]);

if t then ToggleFaceMode;
// restore matrix
glPopMatrix;
end;



procedure DrawModelPivot(model:TModel);
begin
 DrawTreeNode(model.root);
end;

end.

