unit soundunit;

(*

This unit was written by Nicola {MSX} Lugato.

http://msx.rules.it
nicola@lugato.net
nicola.lugato@gmail.com

It is released under the term of
The GNU General Public License as published by the Free
Software Foundation.


Description:

This unit implements the sound system.
It's based on SDL_Mixer

*)


interface

uses Classes, sdl_mixer,sdl, logger;


type
  TSound = class
    private
      fchunk:PMix_Chunk;
      fname:string;
    public
      function getName:string;
      procedure setName(s:string);
      constructor Create(filename:string);
      destructor Destroy; override;
      procedure Play;
  end;

  TSoundList = class(TList)
      function getSound(index:integer):TSound;
      property Sound[index:integer]:TSound read getSound; default;
       function getSoundByName(name:string):TSound;
     end;


function InitSound:boolean;

implementation


destructor TSound.Destroy;
begin
  if fchunk<>nil then
    begin
      Mix_FreeChunk(fchunk);
      fchunk:=nil;
    end;
end;

constructor TSound.Create(filename:string);
begin
  log('loading '+filename);
  fchunk := Mix_LoadWav(pchar(filename));
  if fchunk = nil then
   log('Unable to load wav '+filename);
end;

function InitSound:boolean;
begin
 Log('Initializing Sound and Mixer');
 if SDL_InitSubSystem(SDL_INIT_AUDIO)<>0 then
   begin
     log('No sdl audio: '+SDL_GetError());
     result:=false;
     exit;
   end;
// if Mix_OpenAudio(MIX_DEFAULT_FREQUENCY, MIX_DEFAULT_FORMAT, 2, 512)<>0 then
 if   Mix_OpenAudio( MIX_DEFAULT_FREQUENCY, MIX_DEFAULT_FORMAT, MIX_DEFAULT_CHANNELS, 1024 )<>0 then
   begin
     log('No sdl mixer: '+Mix_getError());
     result:=false;
     exit;
   end;

  result:=TRUE;
end;

function TSoundList.getSound(index:integer):TSound;
begin
result:=TSound(items[index]);
end;

function TSoundList.getSoundByName(name:string):TSound;
var i:integer;
begin
 for i:=0 to count-1 do
  if Sound[i].getname=name then
  begin
   result:=Sound[i];
   exit;
  end;
 result:=nil;
end;

procedure TSound.Play;
begin
  Mix_PlayChannel(-1, fchunk, 0);
end;

function TSound.getName:string;
begin
	result:=fname;
end;
procedure TSound.setName(s:string);
begin
	fname:=s;
end;


end.
