unit stateunit;

interface

uses openglmainloop, SDL;

type

TEventListener = class
  active:boolean;
  procedure DoEnter; virtual; abstract;
  procedure DoExit; virtual; abstract;
  procedure DoLoop; virtual; abstract;
  procedure KeyDownEvent(key:TSDL_KeyboardEvent); virtual; abstract;
  procedure KeyUpEvent(key:TSDL_KeyboardEvent); virtual; abstract;
  procedure MouseDownEvent(event:TSDL_MouseButtonEvent); virtual; abstract;
  procedure MouseUpEvent(event:TSDL_MouseButtonEvent); virtual; abstract;
  procedure MouseMoveEvent(event:TSDL_MouseMotionEvent); virtual; abstract;
  
  procedure ConnectLoop(l:TOpenGlGenericLoop);
  

end;

var ActiveStatus:TEventListener = nil;


procedure ChangeListener(new:TEventListener;loop:TOpenGlGenericLoop);


implementation


procedure ChangeListener(new:TEventListener; loop:TOpenGlGenericLoop);
begin
 if ActiveStatus <> nil then 
  begin
  	ActiveStatus.DoExit;
  	ActiveStatus.active:=false;
  end;
 new.active:=true;  
 ActiveStatus:=new;
 new.DoEnter;
 new.ConnectLoop(loop);
end;


procedure TEventListener.ConnectLoop(l:TOpenGlGenericLoop);
begin
 l.setCycleEvent(DoLoop);
 l.setMouseDownEvent(MouseDownEvent);
 l.setMouseUpEvent(MouseUpEvent);
 l.setMouseMoveEvent(MouseMoveEvent);
 l.setKeyDownEvent(KeyDownEvent);
 l.setKeyUpEvent(KeyUpEvent);
end;

end.
