{** This unit handles writing of simple bitmap monosize fonts in opengl.
Todo: could possibly be enhanced using display lists ? }
unit stringdrawer;

(*

This unit was written by Nicola {MSX} Lugato.

http://msx.rules.it
nicola@lugato.net
nicola.lugato@gmail.com

It is released under the term of
The GNU General Public License as published by the Free
Software Foundation.

*)


interface

uses gl, mediamanagerunit, textureunit;

procedure EndDrawStrings;
procedure drawString(x,y:integer; s:string);
procedure BeginDrawStrings(screen_width,screen_height:integer; texture:TTexture; charW,charH:integer);

implementation

var   CHAR_WIDTH:integer = 6;
      CHAR_HEIGHT:integer = 8;


procedure drawChar(x,y:integer; c:char);
var tx,ty,w,h:single;
    i:byte;
begin
  i:=ord(C)-32;
  tx:=((i mod 16)*CHAR_WIDTH)/128;
  ty:=((i div 16)*CHAR_HEIGHT)/128;
  w := CHAR_WIDTH/128;
  h := CHAR_HEIGHT/128;

  glBegin( GL_TRIANGLE_STRIP  );         // Drawing Using Triangles
    glTexCoord2f(tx,ty);
    glVertex2f(  x,  y );
    glTexCoord2f(tx,ty+h);
    glVertex2f(  x,  y+CHAR_HEIGHT );
    glTexCoord2f(tx+w,ty);
    glVertex2f(  x+CHAR_WIDTH,  y );
    glTexCoord2f(tx+w,ty+h);
    glVertex2f(  x+CHAR_WIDTH,  y+CHAR_HEIGHT );
  glEnd;                            // Finished Drawing The Triangles

end;

procedure BeginDrawStrings(screen_width,screen_height:integer; texture:TTexture; charW,charH:integer);
begin
   CHAR_WIDTH := charW;
   CHAR_HEIGHT := charH;
   // set up ambient
   glDisable(GL_DEPTH_TEST);
   glDisable(GL_LIGHTING);
   glMatrixMode(GL_PROJECTION);
   glPushMatrix;
   glLoadIdentity();
   glOrtho(0, SCREEN_WIDTH, SCREEN_HEIGHT, 0, -100, 100);
   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity();
   texture.Bind;
end;

procedure EndDrawStrings;
begin
  glEnable(GL_LIGHTING);
  glEnable(GL_DEPTH_TEST);
  glMatrixMode(GL_PROJECTION);
  glPopMatrix;
  glMatrixMode(GL_MODELVIEW);
end;




procedure drawString(x,y:integer; s:string);
var t:ttexture;
    i:integer;
begin
  glBlendFunc(GL_SRC_ALPHA, GL_ONE);
  glEnable(GL_BLEND);

  glColor3f(1,1,1);

  for i:=1 to length(s) do
   drawChar(x+(i-1)*CHAR_WIDTH, y, s[i]);

  glDisable(GL_BLEND);
end;


end.
 
