unit highscoreunit;

interface

uses
  Classes, SysUtils, utils;

  const path = 
  {$IFDEF WIN32}
   '\thesheepkiller\';
  {$ELSE}
   '/.thesheepkiller/';
  {$ENDIF}


  type THighscore=class(TStringList)
   private
    procedure loadfile(filename:string);
    procedure savefile(filename:string);
    procedure Sort;
   public
    procedure AddScore(score:integer; name:string);
    function getScore(index:integer):integer;
    procedure load;
    procedure save;
  end;

implementation

procedure THighscore.Sort;
var i:integer;
cont:boolean;
begin
cont:=true;
while cont do
 begin
  cont:=falsE;
for i:=0 to count-2 do
 begin
  if getScore(i)<getScore(i+1) then
    begin
     Move(i, i+1);
     cont := true;
     break;
    end;
 end;

end;
end;

procedure THighscore.loadfile(filename:string);
var f:Textfile;
    s, score, name:string;
    p:integer;

begin
clear;
assignfile(f, filename);
reset(f);
while not eof(f) do
  begin
    readln(f,s);
    p:=pos(' ', s);
    score:=copy(s,1,p-1);
    name:=copy(s,p+1, length(s)-p);
    AddScore(strtoint(score), name);
  end;
closefile(f);

end;

procedure THighscore.savefile(filename:string);
var f:textfile;
    i:integer;
    s:string;
begin
assignfile(f, filename);
rewrite(f);
for i:=0 to count-1 do
  begin
    s:=inttostr(getScore(i))+' '+Strings[i];
    writeln(f,s);
  end;
closefile(f);
end;

function THighscore.getScore(index:integer):integer;
begin
result:=integer(Objects[index]);
end;

procedure THighscore.AddScore(score:integer; name:string);
begin
AddObject(name, pointer(score));
sort;
while count>10 do delete(10);
end;

procedure THighscore.load;
var f:string;
begin
f:=GetPersonalPath+path+'highscore';
if FileExists(f) then
  loadFile(f)
else
  begin
    AddScore(0,'no one');
    AddScore(0,'no one');
    AddScore(0,'no one');
    AddScore(0,'no one');
    AddScore(0,'no one');
    AddScore(0,'no one');
    AddScore(0,'no one');
    AddScore(0,'no one');
    AddScore(0,'no one');
    AddScore(0,'no one');
  end;
end;

function THighscore.save;
var f:string;
begin
f:=GetPersonalPath+path;
writeln(f);
if not DirectoryExists(f) then ForceDirectories(f);

f:=GetPersonalPath+path+'highscore';
savefile(f);

end;

end.

