unit introstatusunit;

interface

uses
  Classes, SysUtils, guiunit,orthounit, guidrawerunit, modelunit, drawmodelunit, gameunit, textureunit,
  openglUnit, globalunit, stateunit, gl, math, glu, guiextraunit,vector2d, types3d, sdl,frustumunit, sdl_mixer;


type

TIntroStatus=class(TEventListener)
 public
  LastTick:Longint;

  Constructor Create;
  Destructor destroy; override;

  procedure DrawFrame(delta:tfloat);
 
  procedure DoEnter; override;
  procedure DoExit; override;
  procedure DoLoop; override;
  procedure KeyDownEvent(key:TSDL_KeyboardEvent);override;
  procedure KeyUpEvent(key:TSDL_KeyboardEvent);override;
  procedure MouseDownEvent(event:TSDL_MouseButtonEvent);override;
  procedure MouseUpEvent(event:TSDL_MouseButtonEvent);override;
  procedure MouseMoveEvent(event:TSDL_MouseMotionEvent);override;
end;

var IntroStatus:TIntroStatus;

implementation

uses mainstatusunit, levelstatusunit;


procedure Rectangle(x,z,w,h:single);
begin
  glBegin( GL_TRIANGLE_STRIP  );         // Drawing Using Triangles

    glTexCoord2f(0,0);
    glVertex3f(  x, 0,  z );

    glTexCoord2f(0,1);
    glVertex3f(  x,0,  z+H );

    glTexCoord2f(1,0);
    glVertex3f(  x+W,0,  z );

    glTexCoord2f(1,1);
    glVertex3f(  x+W,0,  z+H );
  glEnd;                            // Finished Drawing The Triangle
end;




Constructor TIntroStatus.Create;
var mus:PMix_Music;
begin
mus:=mix_loadmus('media/yeeha.xm');
mix_playmusic(mus, -1);
end;

Destructor TIntroStatus.destroy;
begin
end;


procedure TIntroStatus.DoEnter;
var x:TBase;
    i:integer;
begin
global.keystate.reset;	
end;

procedure TIntroStatus.DoExit;
var t:TTexture;
begin
t:=global.man.getTextureByName('intro');
// @todo free the texture here!

global.man.getSoundByName('x2').play;
end;

procedure TIntroStatus.DoLoop;
var durata:longint;
    nowa:longint;
    s:TFloat;

begin
nowa := SDL_GetTicks;
durata := nowa - lastTick;
lastTick := nowa;

s:=max(epsilon, durata/1000);  // avoid div by zero
drawframe(s);
end;

procedure TIntroStatus.DrawFrame(delta:tfloat);
var i,x,y:integer;
    b:TBase;
    q:PGLUquadric;
begin

  glClear( GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);

  // start calculation of the matrix (by loading identity)
  glLoadIdentity;
  gluLookAt(20,20,20, 0,0,0,0,1,0);

  glDisable(GL_LIGHTING);
  glenable(GL_TEXTURE_2D);

  // switch to ortho projection
  BeginOrtho(SCREEN_WIDTH, SCREEN_HEIGHT);

  global.man.getTextureByName('font').bind;
  glColor3f(0,0,0);
  DrawString(10,10, 'FPS: '+inttostr(round(1/delta)));
 
  global.man.getTextureByName('intro').bind;
  glColor3f(1,1,1);
  glBegin( GL_TRIANGLE_STRIP  );
    glTexCoord2f(0,0);
    glVertex2f(  0,0 );
    glTexCoord2f(0,1);
    glVertex2f(  0,600);
    glTexCoord2f(1,0);
    glVertex2f(  800,0 );
    glTexCoord2f(1,1);
    glVertex2f(  800,600 );
  glEnd;

  
  // go back to normal projection
  EndOrtho;
  

  // finally, show our nice frame!
  SDL_GL_SwapBuffers;

end;

procedure TIntroStatus.MouseDownEvent(event:TSDL_MouseButtonEvent);
begin
 
end;

procedure TIntroStatus.MouseUpEvent(event:TSDL_MouseButtonEvent);
begin
 
end;

procedure TIntroStatus.MouseMoveEvent(event:TSDL_MouseMotionEvent);
begin
 
 global.mx:=event.x;
 global.my:=event.y;
end;

procedure TIntroStatus.KeyDownEvent(key:TSDL_KeyboardEvent);
begin
 
 
 if key.keysym.sym = SDLK_SPACE then ChangeListener(LevelStatus, global.loop);
 if key.keysym.sym = SDLK_ESCAPE then global.loop.stoploop;
end;

procedure TIntroStatus.KeyUpEvent(key:TSDL_KeyboardEvent);
begin
end;

end.

