unit mainstatusunit;

interface

uses
  Classes, SysUtils, guiunit,orthounit, guidrawerunit, modelunit, drawmodelunit, gameunit, msxmath, logger,
  openglUnit, globalunit, stateunit, fontunit,
  gl, math, glu, guiextraunit,vector2d, types3d, sdl,frustumunit;


type


TMainStatus=class(TEventListener)
 public
  animFence:TRealTimeModel;
  LastTick:Longint;
  list:TBaseList;
  
  culler:TFrustumCuller;
  starttime:longint;
  timetoend:TFloat; // seconds that pass between the last sheep killed (or the player diyng) and the end of level
  
  campos, camtarget:msxmath.TVector;

  Constructor Create;
  Destructor destroy; override;

  procedure InitGui;
  procedure DrawFrame(delta:tfloat);
  function TestOcclusion(a:TBase):boolean;
  procedure DrawField;

  procedure DoEnter; override;
  procedure DoExit; override;
  procedure DoLoop; override;
  procedure KeyDownEvent(key:TSDL_KeyboardEvent);override;
  procedure KeyUpEvent(key:TSDL_KeyboardEvent);override;
  procedure MouseDownEvent(event:TSDL_MouseButtonEvent);override;
  procedure MouseUpEvent(event:TSDL_MouseButtonEvent);override;
  procedure MouseMoveEvent(event:TSDL_MouseMotionEvent);override;
end;

var MainStatus:TMainStatus;

implementation

uses introstatusunit, levelstatusunit, gameoverstatusunit;

function MillisToString(millis:cardinal):string;
var seconds, minutes, decimal:cardinal;
    s:string;
begin
// @todo make this method better !!!

seconds:=millis div 1000;
minutes:=seconds div 60;
seconds:=seconds mod 60;
// result:=inttostr(minutes)+':'+inttostr(seconds)+':'+inttostr(decimal);
result:=format('%2D:%2D', [minutes, seconds]);
result:=StringReplace(result,' ','0', [rfReplaceAll]);
end;


procedure Rectangle(x,z,w,h:single);
begin
  glBegin( GL_TRIANGLE_STRIP  );         // Drawing Using Triangles

    glTexCoord2f(0,0);
    glVertex3f(  x, 0,  z );

    glTexCoord2f(0,1);
    glVertex3f(  x,0,  z+H );

    glTexCoord2f(1,0);
    glVertex3f(  x+W,0,  z );

    glTexCoord2f(1,1);
    glVertex3f(  x+W,0,  z+H );
  glEnd;                            // Finished Drawing The Triangle
end;

procedure Rectangle2d(x,z,w,h:single);
begin
  glBegin( GL_TRIANGLE_STRIP  );         // Drawing Using Triangles

    glTexCoord2f(0,0);
    glVertex2f(  x,  z );

    glTexCoord2f(0,1);
    glVertex2f(  x,  z+H );

    glTexCoord2f(1,0);
    glVertex2f(  x+W,  z );

    glTexCoord2f(1,1);
    glVertex2f(  x+W,  z+H );
  glEnd;                            // Finished Drawing The Triangle
end;



Constructor TMainStatus.Create;
begin
list:=TBaseList.create;
list.restart;

InitGui;

animFence:=TRealTimeModel.create;
animFence.load('media/fence.model', global.man);



end;

Destructor TMainStatus.destroy;
begin
list.destroy;
animFence.free;
end;

procedure TMainStatus.initGui;
begin
end;


procedure TMainStatus.DoEnter;
var x:TBase;
    i:integer;
begin	
timetoend:=0;
global.keystate.reset;
culler:=TFrustumCuller.create;

starttime:=SDL_GetTicks;
end;

procedure TMainStatus.DoExit;
begin
culler.free;
global.man.getSoundByName('x2').play;
end;

function TMainStatus.TestOcclusion(a:TBase):boolean;
var raytarget, spherepos:msxmath.TVector;
//    dista, distb:TFloat;
begin

raytarget.x:=list.player.position.x;
raytarget.y:=list.player.modelsize;
raytarget.z:=list.player.position.y;
raytarget:=msxmath.sub(raytarget, campos);
msxmath.normalize(raytarget);

spherepos.x:=a.position.x;
spherepos.y:=a.modelsize;
spherepos.z:=a.position.y;

result:=sphereraycollision(campos, raytarget, spherepos, a.modelsize);
end;

procedure TMainStatus.DrawField;
var x,y:integer;
begin
  glPushMatrix;
  glTranslatef(0,0,2);
  for x:=0 to AREASIZE-1 do
    begin
      DrawRealtimeModel(animFence);
      glTranslatef(0,0,4);
    end;
  glPopMatrix;

  glPushMatrix;
  glTranslatef(2,0,0);
  glRotatef(-90,0,1,0);
  for x:=0 to AREASIZE-1 do
    begin
      DrawRealtimeModel(animFence);
      glTranslatef(0,0,-4);
    end;
  glPopMatrix;


  glPushMatrix;
  glTranslatef(AREASIZE*TILESIZE,0,2);
  glRotatef(180,0,1,0);
  for x:=0 to AREASIZE-1 do
    begin
      DrawRealtimeModel(animFence);
      glTranslatef(0,0,-4);
    end;
  glPopMatrix;

  glPushMatrix;
  glTranslatef(2,0,AREASIZE*TILESIZE);
  glRotatef(90,0,1,0);
  for x:=0 to AREASIZE-1 do
    begin
      DrawRealtimeModel(animFence);
      glTranslatef(0,0,4);
    end;
  glPopMatrix;



  glenable(GL_TEXTURE_2D);
  glDisable(GL_LIGHTING);
  glColor3f(1,1,1);
  global.man.getTextureByName('tile1').bind;

  for x:=0 to AREASIZE-1 do
    for y:=0 to AREASIZE-1 do
     rectangle(x*4,y*4,4,4);

  glDisable(GL_TEXTURE_2D);
  glEnable(GL_LIGHTING);


end;

procedure TMainStatus.DoLoop;
var durata:longint;
    nowa:longint;
    s:TFloat;

begin
	if list=nil then exit;
  nowa := SDL_GetTicks;
  durata := nowa - lastTick;
  lastTick := nowa;

  s:=max(epsilon, durata/1000);  // avoid div by zero
  drawframe(s);
end;

procedure TMainStatus.DrawFrame(delta:tfloat);
var i,x,y:integer;
    b:TBase;
    q:PGLUquadric;
    w:TBase;
begin
  list.update(delta);
  

  if (list.numsheep = 0) or (list.player.dead) then
   timetoend:=timetoend+delta;
   
  if timetoend>5 then
    begin
      if list.player.dead or (list.player.anim.currentanim=ANIM_DIE) or (list.player.life<1) then
       begin
    	changelistener(gameoverstatus, global.loop);
    	exit;
       end else if list.numsheep=0 then
       begin
        list.nextlevel;
    	changelistener(levelstatus, global.loop);
    	exit;
       end;
    end;

  glClear( GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);

  // start calculation of the matrix (by loading identity)
  glLoadIdentity;
  campos.x:=20+list.player.position.x;
  campos.y:=20;
  campos.z:=20+list.player.position.y;
  camtarget.x:=list.player.position.x;
  camtarget.y:=0;
  camtarget.z:=list.player.position.y;
  gluLookAt(campos.x, campos.y, campos.z, camtarget.x, camtarget.y, camtarget.z,0,1,0);
  culler.calculate;

  glEnable(GL_LIGHTING);
  glDisable(GL_TEXTURE_2D);
  SetMaterialColor(1,1,1);
  
  DrawField;

  
  for i:=0 to list.count-1 do
    begin
    	b:=list[i];
    	if culler.IsSphereWithin(b.position.x,3,b.position.y,3) then
    	  begin
            b.anim.interpolate;
	    glPushMatrix;
	    glTranslatef(b.position.x,0, b.position.y);
	    glRotatef(b.angle*180/pi,0,1,0);
            if (b=list.player) or (not (b is TTree)) or (not testocclusion(b)) then
    	        DrawRealTimeModel(b.anim.model)
            else
              begin
                glEnable(gl_Blend);
                glBlendFunc(GL_SRC_COLOR, GL_DST_COLOR);
                DrawRealTimeModel(b.anim.model);
                glDisable(gl_Blend);
              end;

	    glPopMatrix;
          end;
        end;

  glDisable(GL_LIGHTING);
  glenable(GL_TEXTURE_2D);

  // switch to ortho projection
  BeginOrtho(SCREEN_WIDTH, SCREEN_HEIGHT);
  glEnable(gl_Blend);
  glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);




  global.man.getTextureByName('font').bind;
  glColor3f(0,0,0);
  DrawString(10,10, 'FPS: '+inttostr(round(1/delta)));
  DrawString(100,10, 'TIME: '+millistostring(SDL_GETTicks - starttime));
//  DrawString(10,580, 'LIFE: '+inttostr(list.player.life));
//  DrawString(10,560, 'SHEEPS: '+inttostr(list.numSheep));
//  DrawString(10,540, 'SCORE: '+inttostr(list.score));

  global.man.getTextureByName('title').bind;
  glColor3f(1,1,1);
  glBegin( GL_TRIANGLE_STRIP  );
    glTexCoord2f(0,0);
    glVertex2f(  0,-20 );
    glTexCoord2f(0,1);
    glVertex2f(  0,200-20);
    glTexCoord2f(1,0);
    glVertex2f(  200,0-20 );
    glTexCoord2f(1,1);
    glVertex2f(  200,200-20 );
  glEnd;


global.man.getTextureByName('heart').bind;
Rectangle2d(0,480,32,32);
drawracestring(40,480,inttostr(list.player.life),0.5);

global.man.getTextureByName('sheep').bind;
Rectangle2d(0,520,32,32);
drawracestring(40,520,inttostr(list.numsheep),0.5);

global.man.getTextureByName('point').bind;
Rectangle2d(0,560,32,32);
drawracestring(40,560,inttostr(list.score),0.5);


(*  global.man.getTextureByName('heart').bind;
  for i:=0 to list.player.life-1 do
  begin
  glBegin( GL_TRIANGLE_STRIP  );
    glTexCoord2f(0,0);
    glVertex2f(  i*32,500 );
    glTexCoord2f(0,1);
    glVertex2f(  i*32,532);
    glTexCoord2f(1,0);
    glVertex2f(  i*32+32,500 );
    glTexCoord2f(1,1);
    glVertex2f(  i*32+32,532 );
  glEnd;
  end;

  global.man.getTextureByName('sheep').bind;
  for i:=0 to list.numsheep-1 do
  begin
  glBegin( GL_TRIANGLE_STRIP  );
    glTexCoord2f(0,0);
    glVertex2f(  i*32,540 );
    glTexCoord2f(0,1);
    glVertex2f(  i*32,572);
    glTexCoord2f(1,0);
    glVertex2f(  i*32+32,540 );
    glTexCoord2f(1,1);
    glVertex2f(  i*32+32,572 );
  glEnd;
  end;

*)
  // go back to normal projection
  EndOrtho;
  

  // finally, show our nice frame!
  SDL_GL_SwapBuffers;

end;

procedure TMainStatus.MouseDownEvent(event:TSDL_MouseButtonEvent);
begin

end;

procedure TMainStatus.MouseUpEvent(event:TSDL_MouseButtonEvent);
begin

end;

procedure TMainStatus.MouseMoveEvent(event:TSDL_MouseMotionEvent);
begin
 
 global.mx:=event.x;
 global.my:=event.y;
end;

procedure TMainStatus.KeyDownEvent(key:TSDL_KeyboardEvent);
begin

 global.keystate.processKeyDown(key.keysym.sym);
 if key.keysym.sym = SDLK_ESCAPE then global.loop.stoploop;
end;

procedure TMainStatus.KeyUpEvent(key:TSDL_KeyboardEvent);
begin
 global.keystate.processKeyUp(key.keysym.sym);
end;


end.

