unit mainunit;

interface

uses
  openglmainloop, screenunit, openglunit, meshunit,
  SDL, GLU, GL,  mediamanagerunit, soundunit,
  types3d, SysUtils, guiunit,globalunit,stateunit,
  glmeshunit, orthounit, mainstatusunit, sdl_mixer,
  frustumunit, math, msxmath, introstatusunit, levelstatusunit,
  keyboardunit, gameoverstatusunit;


const LightAmbient:array [0..3] of GLfloat = (0.3, 0.3, 0.3, 1);
const LightDiffuse:array [0..3] of GLfloat = (0.7, 0.7, 0.7, 1);
const LightSpecular:array [0..3] of GLfloat = (1, 1, 1, 1);
const LightPosition:array [0..3] of GLfloat = (32*4, 200,32*4, 1);


type

// this class simply represent the program
TProg = class
  procedure DrawLoadingScreen;
  procedure initGl;
  procedure Start;
  procedure Cleanup;
end;



implementation

procedure TProg.DrawLoadingScreen;
begin
  glClear( GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);

  glLoadIdentity;

  glDisable(GL_LIGHTING);
  glenable(GL_TEXTURE_2D);

  // switch to ortho projection
  BeginOrtho(SCREEN_WIDTH, SCREEN_HEIGHT);

  global.man.getTextureByName('loading').bind;
  glColor3f(1,1,1);
  glBegin( GL_TRIANGLE_STRIP  );
    glTexCoord2f(0,0);
    glVertex2f(  250,100 );
    glTexCoord2f(0,1);
    glVertex2f(  250,356);
    glTexCoord2f(1,0);
    glVertex2f(  506,100 );
    glTexCoord2f(1,1);
    glVertex2f(  506,356 );
  glEnd;


  // go back to normal projection
  EndOrtho;


  // finally, show our nice frame!
  SDL_GL_SwapBuffers;

end;

procedure TProg.initGl;
begin
	// opengl initialization
  glMatrixMode(GL_MODELVIEW);
  glEnable(gl_Blend);
  glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
  glDisable(GL_LIGHTING);
  glClearColor(0.7,1,1,0);

 SDL_EnableKeyRepeat(SDL_DEFAULT_REPEAT_DELAY,SDL_DEFAULT_REPEAT_INTERVAL);
 SDL_EnableUnicode(1);

 glEnable(GL_TEXTURE_2D);

 // glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
 glEnable(GL_CULL_FACE);
 glCullFace(GL_Back);

 glLightfv(GL_LIGHT1, GL_AMBIENT, @LightAmbient);
 glLightfv(GL_LIGHT1, GL_DIFFUSE, @LightDiffuse);
 glLightfv(GL_LIGHT1, GL_POSITION, @LightPosition);
 glEnable(GL_LIGHT1);

end;


procedure TProg.Cleanup;
begin
     Global.screen.finalize;
end;

procedure TProg.Start;
//var login:TLoginStatus;
begin
// StateManager:=TStateManager.Create;

 Global.screen:=TScreen.Create('The Sheep Killer!', 800, 600, 16, ParamStr(1)='-fs', 500);
 if not Global.screen.Initialize then exit;

 if not initsound then exit;

 // keyboard state helper
 Global.keystate:=tkeystate.create;

 // start up our kind media manager
 Global.man:=TFileMediaManager.Create;

 // set up the main loop
 global.Loop:=TOpenGlRealTimeLoop.create;

 // initialize some other things
 initGl;
 DrawLoadingScreen;


 MainStatus:=TMainStatus.create;
 IntroStatus:=TIntroStatus.create;
 LevelStatus:=TLevelStatus.create;
 gameoverstatus:=TGameOverStatus.create;
 ChangeListener(IntroStatus, global.loop);

 // ready to go! :P
 global.loop.StartLoop;

end;


end.

