unit utils;

interface

function GetPersonalPath : string;

implementation

  {$IFDEF WIN32}
  uses windows, Classes, SysUtils;
  const NOERROR:integer=0;
        CSIDL_APPDATA                       = $001a;
  type IMalloc = interface(IUnknown)
    procedure Free(pv: Pointer); stdcall;
  end;
  PItemIdList=pointer;
  function SHGetMalloc(var ppMalloc: IMalloc): HResult; stdcall; external 'shell32.dll';
  function SHGetSpecialFolderLocation(hwndOwner: HWND; nFolder: Integer;  var ppidl: PItemIDList): HResult; stdcall;  external 'shell32.dll';
  function SHGetPathFromIDList(pidl: PItemIDList; pszPath: PChar): BOOL; stdcall; external 'shell32.dll';
  {$ELSE}
   uses libc;
  {$ENDIF}

function GetPersonalPath : string;
var
  {$IFDEF WIN32}
  shellMalloc: IMalloc;
  ppidl: PItemIdList;
  PerDir: string;
  {$ELSE}
   ppwd :PPasswordRecord;
  {$ENDIF}
begin
  {$IFDEF WIN32}
  ppidl := nil;
  try
    if SHGetMalloc(shellMalloc) = NOERROR then
    begin
      SHGetSpecialFolderLocation(0, CSIDL_APPDATA,
ppidl);
      SetLength(Result, MAX_PATH);
      if not SHGetPathFromIDList(ppidl, PChar(Result)) then raise exception.create('SHGetPathFromIDList failed : invalid pidl');
      SetLength(Result, lStrLen(PChar(Result)));
    end;
  finally
   if ppidl <> nil then
         shellMalloc.free(ppidl);
  end;
  {$ELSE}
   ppwd := getpwuid( getuid() );
  Result := ppwd^.pw_dir;
  {$ENDIF}
end; 


(*
uses
  {$IFDEF WIN32}
  ShlObj; // Only one unit, yeah!
  {$ELSE}
  libc; // Not sure where getpwuid(),  getuid() and PPasswordRecord live
  {$ENDIF}

function GetPersonalPath : string;
var
  {$IFDEF WIN32}
   Res: Bool;
   Path: array[0..Max_Path] of Char;
  {$ELSE}
   ppwd :PPasswordRecord;
  {$ENDIF}
begin
  {$IFDEF WIN32}
   Res := ShGetSpecialFolderPath(0, Path, , False);
   if not Res then raise Exception.Create(
     'Could not determine My Documents path');
   Result := Path;
  {$ELSE}
   ppwd := getpwuid( getuid() );
  Result := ppwd^.pw_dir;
  {$ENDIF}
end;


NOTE :if you change CSIDL_PERSONAL to CSIDL_APPDATA this will give you the path to where Applications store their data, which for games would be a much better place to store things than in the My Documents folder.
*)

end.
